using DAL.Models.Entities;
using DAL.Models.Filters;
using HRD.WebApi.Repositories;
using Microsoft.EntityFrameworkCore;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace DAL.Repositories
{
    public class WebAppToWebAppRoleRepository : BaseRepository<WebAppToWebAppRole>
    {
        public WebAppToWebAppRoleRepository(WebApiContext context) : base(context)
        {
        }

        public async Task<List<WebAppToWebAppRole>> GetListByFilterAsync(WebAppFilter filter, bool asNoTracking = true)
        {
            var items = this.RepositoryContext.Set<WebAppToWebAppRole>().AsQueryable();

            if (filter.WebAppId != null && filter.WebAppId != 0)
            {
                items = items.Where(x => x.WebAppId == filter.WebAppId);
            }

            return asNoTracking ? await items.AsNoTracking().ToListAsync() : await items.ToListAsync();
        }
    }
}